Subject: [weirds] I-D Action: draft-ietf-weirds-rdap-query-08.txt

From: [email-masked]
Date: Mon, 18 Nov 2013 17:55:47 -0800

A New Internet-Draft is available from the on-line Internet-Drafts directories.
 This draft is a work item of the Web Extensible Internet Registration Data Service Working Group of the IETF.

	Title           : Registration Data Access Protocol Query Format
	Author(s)       : Andrew Lee Newton
                          Scott Hollenbeck
	Filename        : draft-ietf-weirds-rdap-query-08.txt
	Pages           : 16
	Date            : 2013-11-18

Abstract:
   This document describes uniform patterns to construct HTTP URLs that
   may be used to retrieve registration information from registries
   (including both Regional Internet Registries (RIRs) and Domain Name
   Registries (DNRs)) using "RESTful" web access patterns.

The IETF datatracker status page for this draft is:
https://datatracker.ietf.org/doc/draft-ietf-weirds-rdap-query

There's also a htmlized version available at:
http://tools.ietf.org/html/draft-ietf-weirds-rdap-query-08

A diff from the previous version is available at:
http://www.ietf.org/rfcdiff?url2=draft-ietf-weirds-rdap-query-08

Please note that it may take a couple of minutes from the time of submission
until the htmlized version and diff are available at tools.ietf.org.

Internet-Drafts are also available by anonymous FTP at:
ftp://ftp.ietf.org/internet-drafts/

---

From: "Hollenbeck, Scott" <[email-masked]>
Date: Tue, 19 Nov 2013 01:58:07 +0000

> -----Original Message-----
> From: weirds [mailto:[email-masked]] On Behalf Of internet-
> [email-masked]
> Sent: Monday, November 18, 2013 8:56 PM
> To: [email-masked]
> Cc: [email-masked]
> Subject: [weirds] I-D Action: draft-ietf-weirds-rdap-query-08.txt
> 
> 

This version of the document attempts to capture the results of our discussion in Vancouver and the on-list feedback that followed. Please pay special attention to the URI format and search processing changes.

Scott

---

From: "John Levine" <[email-masked]>
Date: 19 Nov 2013 16:10:36 -0000

>This version of the document attempts to capture the results of our discussion in Vancouver and the on-list feedback
>that followed. Please pay special attention to the URI format and search processing changes.

Keeping in mind that I still think that the .well-known thing is a
crock, it looks fine.  The search part seems about as good as it can
be.

If we come up with a bootstrap that provides URI prefixes rather than
just host names, we might need to twiddle the .well-known text, but
we can burn that bridge when we come to it.

R's,
John

---

From: Andy Newton <[email-masked]>
Date: Tue, 19 Nov 2013 16:28:19 +0000

>we can burn that bridge when we come to it.

Wish I had thought about this yesterday, but perhaps we can word the draft
to say that in the absence of a base path in the URL from a bootstrapping
mechanism, apps should use .well-known.

-andy

---

From: Simon Perreault <[email-masked]>
Date: Tue, 19 Nov 2013 11:30:20 -0500

Le 2013-11-19 11:10, John Levine a écrit :
> crock, it looks fine.

Putting on my implementer hat, the .well-known thing is really 
confusing. The new text does not explain why .well-known is needed with 
RDAP or what role it is supposed to play in an RDAP implementation. How 
is it supposed to be implemented? Is there anything special that a 
client needs to do? How is .well-known supposed to help the client find 
what it's looking for?

(And I don't know how to answer those questions.)

Simon
-- 
DTN made easy, lean, and smart --> http://postellation.viagenie.ca
NAT64/DNS64 open-source        --> http://ecdysis.viagenie.ca
STUN/TURN server               --> http://numb.viagenie.ca

---

From: "Hollenbeck, Scott" <[email-masked]>
Date: Tue, 19 Nov 2013 17:03:33 +0000

> From: weirds [mailto:[email-masked]] On Behalf Of Simon
> Perreault
> Sent: Tuesday, November 19, 2013 11:30 AM
> To: [email-masked]
> Subject: [weirds] Implementing .well-known [Was: Re: I-D Action: draft-
> ietf-weirds-rdap-query-08.txt]
> 

I don't know how to answer those questions, either, but that's why there's a normative reference to RFC 5785. It explains the rationale.

Scott

---

From: Simon Perreault <[email-masked]>
Date: Tue, 19 Nov 2013 12:59:43 -0500

> I don't know how to answer those questions, either, but that's why there's a normative reference to RFC 5785. It explains the rationale.

Well, RFC 5785 explains the rationale behind .well-known in general, 
which I understand. What I'm missing is the rationale for .well-known 
*with RDAP*.

I mean, .well-known is used when I'm looking for a site resource. That 
implies I'm starting with a site. But that does not happen with RDAP. 
None of the bootstrapping methods proposed uses .well-known. So when is 
it supposed to be used? Why would a client be looking for "example.com's 
RDAP service"? How would it know that its request is to be answered by 
example.com's RDAP service in the first place? Did the user configure 
example.com into the client? Why? Where did the user obtain example.com 
as a configuration parameter? etc. etc. etc.

Simon

---

From: "Hollenbeck, Scott" <[email-masked]>
Date: Tue, 19 Nov 2013 18:23:20 +0000

> From: Simon Perreault [mailto:[email-masked]]
> Sent: Tuesday, November 19, 2013 1:00 PM
> To: Hollenbeck, Scott
> Cc: [email-masked]
> Subject: Re: [weirds] Implementing .well-known [Was: Re: I-D Action:
> draft-ietf-weirds-rdap-query-08.txt]
> 
> > I don't know how to answer those questions, either, but that's why
> there's a normative reference to RFC 5785. It explains the rationale.
> 

Paging Mark Nottingham (cc'd here)... ;)

Scott

---

From: "John Levine" <[email-masked]>
Date: 19 Nov 2013 18:25:31 -0000

>which I understand. What I'm missing is the rationale for .well-known 

As I understand it, if we don't, the web thought police will make our
life unpleasant in the IESG.

I concur with the suggestion to change the wording a little to say
that you use .well-known/rdap if you don't have a URI prefix from
already.

---

From: "Murray S. Kucherawy" <[email-masked]>
Date: Tue, 19 Nov 2013 21:06:16 -0800

> mechanism, apps should use .well-known.
As I understand the issue, that would probably fly.

-MSK

---

From: "Hollenbeck, Scott" <[email-masked]>
Date: Wed, 20 Nov 2013 11:58:00 +0000

From: weirds [mailto:[email-masked]] On Behalf Of Murray S. Kucherawy
Sent: Wednesday, November 20, 2013 12:06 AM
To: Andy Newton
Cc: John Levine; [email-masked]
Subject: Re: [weirds] I-D Action: draft-ietf-weirds-rdap-query-08.txt

On Tue, Nov 19, 2013 at 8:28 AM, Andy Newton <[email-masked]<mailto:[email-masked]>> wrote:

As I understand the issue, that would probably fly.
Specific text would be much appreciated.

Scott

---

From: "Hollenbeck, Scott" <[email-masked]>
Date: Wed, 20 Nov 2013 12:00:16 +0000

http://datatracker.ietf.org/doc/draft-ietf-weirds-rdap-query/

See Sections 3 and 7.

Scott

> From: Mark Nottingham [mailto:[email-masked]]
> Sent: Wednesday, November 20, 2013 12:15 AM
> To: Hollenbeck, Scott
> Cc: Simon Perreault; [email-masked]
> Can you send a reference to the new text?
> 
> Cheers,
> 
> 
> On 20/11/2013, at 5:23 AM, "Hollenbeck, Scott"
> <[email-masked]> wrote:
> 
> >>>> RDAP or what role it is supposed to play in an RDAP
> implementation.
> >> How
> Mark Nottingham   http://www.mnot.net/
> 
>

---

From: Mark Nottingham <[email-masked]>
Date: Wed, 20 Nov 2013 16:14:35 +1100

Cheers,

---

From: Andy Newton <[email-masked]>
Date: Wed, 20 Nov 2013 15:52:23 +0000

From: <Hollenbeck>, Scott Hollenbeck <[email-masked]<mailto:[email-masked]>>
Date: Wednesday, November 20, 2013 6:58 AM
To: "Murray S. Kucherawy" <[email-masked]<mailto:[email-masked]>>, Andrew Newton <[email-masked]<mailto:[email-masked]>>
Cc: John Levine <[email-masked]<mailto:[email-masked]>>, "[email-masked]<mailto:[email-masked]>" <[email-masked]<mailto:[email-masked]>>
Subject: RE: [weirds] I-D Action: draft-ietf-weirds-rdap-query-08.txt

From: weirds [mailto:[email-masked]] On Behalf Of Murray S. Kucherawy
Sent: Wednesday, November 20, 2013 12:06 AM
To: Andy Newton
Cc: John Levine; [email-masked]<mailto:[email-masked]>
Subject: Re: [weirds] I-D Action: draft-ietf-weirds-rdap-query-08.txt

Scott

Let's see if this works…

OLD:
   The uniform patterns start with a base URL [RFC3986] specified by
   each registry or any other service provider offering this service.
   The base URL is followed by a path prefix that identifies a well
   known [RFC5785] location for per-resource metadata, ".well-known/
   rdap".

NEW:
   The uniform patterns start with a base URL [RFC3986] consisting of a scheme, authority, and a base path. Unless constructed through a bootstrapping or discovery process, the base path is a well known [RFC5785] location for per-resource meta-data, ".well-known/rdap".

-andy

---

From: "Hollenbeck, Scott" <[email-masked]>
Date: Mon, 25 Nov 2013 13:30:12 +0000

> Sent: Sunday, November 24, 2013 7:36 PM
> To: Hollenbeck, Scott
> On 20/11/2013, at 11:00 PM, "Hollenbeck, Scott"
> From Section 3:
> """
>    Uniform query patterns start with a base URL [RFC3986] specified by
>    rdap".  The path prefix is followed by a path segment that is
>    specific to each type of resource.  The characters used to form a
>    path segment are limited to those that can be used to form a URI as
>    specified in RFC 3986 [RFC3986].  This specification uses the
>    following base URL and path prefix in examples:
> 
>    http://example.com/.well-known/rdap
> 
>    The base URL is specific to each server implementation.  The ".well-
>    known/rdap" path prefix MUST be present.
> """
> 
> This is a bit... strange. A base URI is combined with a relative URI as
> per RFC3986 section 5. However, the text above could easily be misread
> to lead a naive implementer to believe they can specify any URL and
> append ".well-known/rdap". How about:
> 
> """
> RDAP queries use well-known URLs [RFC5785] with the "rdap" prefix.
> Generally, a registry or other service provider will provide a base URL
> that identifies the protocol, host and port, and this will be used as a
> base URL that the well-known URL is resolved against, as per RFC3986
> Section 5.
> 
> For example, if the base URL is "http://example.com/", all RDAP query
> URLs will begin with "http://example.com/.well-known/rdap".
> 
> Note that path and query information in the base URL are not used,
> because the well-known URL is rooted at "/.well-known/rdap"; for
> example, if a registry provides "http://example.net/other/path" as a
> base URL, RDAP query URLs will still begin with
> "http://example.net/.well-known/rdap".
> """
> 
> Otherwise, looks fine to me.

I'm not surprised that it's strange :). I don't completely understand the need for a well-known URL, so this is the kind of hooey one gets from a clueless author. Your suggested replacement text is fine with me - thanks.

> I'm not as familiar with RDAP's use cases as you are, undoubtedly. What
> was the case before using .well-known -- i.e. what information did you
> start with, and how did you get it?

There is a direct tie here to the unresolved bootstrapping conversation that we're having. Think back to how you use WHOIS today. We're trying to find a way to help clients that have some query parameters received from a user (like a domain name or an IP address) identify the server that can provide an authoritative answer. In the case of a complete domain name (say example.com) the question becomes one of "which server can provide an answer for a .com domain name?", and we're currently debating if/how both DNS-based and IANA-based approaches might work. There are other query types (entity queries, for example) that IMHO don't have a straightforward mapping to a server resource. I'm sure others will chime in here with additional info.

Scott

---

From: Mark Nottingham <[email-masked]>
Date: Mon, 25 Nov 2013 11:36:00 +1100

From Section 3:

"""

This is a bit... strange. A base URI is combined with a relative URI as per RFC3986 section 5. However, the text above could easily be misread to lead a naive implementer to believe they can specify any URL and append ".well-known/rdap". How about:

"""
RDAP queries use well-known URLs [RFC5785] with the "rdap" prefix. Generally, a registry or other service provider will provide a base URL that identifies the protocol, host and port, and this will be used as a base URL that the well-known URL is resolved against, as per RFC3986 Section 5.

For example, if the base URL is "http://example.com/", all RDAP query URLs will begin with "http://example.com/.well-known/rdap". 

Note that path and query information in the base URL are not used, because the well-known URL is rooted at "/.well-known/rdap"; for example, if a registry provides "http://example.net/other/path" as a base URL, RDAP query URLs will still begin with "http://example.net/.well-known/rdap". 
"""

> as a configuration parameter? etc. etc. etc.

I'm not as familiar with RDAP's use cases as you are, undoubtedly. What was the case before using .well-known -- i.e. what information did you start with, and how did you get it?

---

From: Andy Newton <[email-masked]>
Date: Mon, 25 Nov 2013 15:46:31 +0000

On 11/25/13 8:30 AM, "Hollenbeck, Scott" <[email-masked]> wrote:

>There is a direct tie here to the unresolved bootstrapping conversation
>that we're having. Think back to how you use WHOIS today. We're trying to
>find a way to help clients that have some query parameters received from
>a user (like a domain name or an IP address) identify the server that can
>provide an authoritative answer. In the case of a complete domain name
>(say example.com) the question becomes one of "which server can provide
>an answer for a .com domain name?", and we're currently debating if/how
>both DNS-based and IANA-based approaches might work. There are other
>query types (entity queries, for example) that IMHO don't have a
>straightforward mapping to a server resource. I'm sure others will chime
>in here with additional info.

Regardless of the bootstrap method, it will return a base URL.

For example, http://example.com/blahblah. To use that base URL for an IP
address lookup, the RDAP URL would then be
http://example.com/blahblah/ip/192.168.0.0 . At least that was the current
trajectory of the RDAP specs before we mixed in .well-known/rdap.

I think the question this working group has is why do we have to do
.well-known/rdap when our bootstrapping provides base URLs that do not
dictate a path prefix nor are we attempting to standardize that all URLs
that have a path starting with /ip or /domain are RDAP URLs.

-andy

---

From: Marc Blanchet <[email-masked]>
Date: Mon, 25 Nov 2013 11:11:08 -0500

> Regardless of the bootstrap method, it will return a base URL.

well, that means if we do DNS, we ought to do NAPTR, which brings its own issues.

> that have a path starting with /ip or /domain are RDAP URLs.

My take: if we agree on a bootstrap method that always return a URL, then we don't need the .well-known. And I think we can argue it in front of IESG.

Regards, Marc.

> 
> -andy
> 
> _______________________________________________
> weirds mailing list
> [email-masked]
> https://www.ietf.org/mailman/listinfo/weirds

---

From: "John Levine" <[email-masked]>
Date: 25 Nov 2013 16:37:55 -0000

>Regardless of the bootstrap method, it will return a base URL.

If we use SRV or the like, it'll just be a host name.

R's,
John

---

From: Simon Perreault <[email-masked]>
Date: Mon, 25 Nov 2013 12:55:49 -0500

> My take: if we agree on a bootstrap method that always return a URL, then we don't need the .well-known. And I think we can argue it in front of IESG.

+1

Simon